/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   (C) 2002-2003 Dakshinamurthy K (kd@subexgroup.com)                    *
 ***************************************************************************/

#ifndef EMP_HPP
#define EMP_HPP

#include <iostream>
#include <iomanip>
#include <dame/date.hpp>

namespace Dame {
	namespace ExampleDb {

class emp {
	int			Empno ;
	std::string	Name ;
	std::string	Job ;
	int			Manager ;
	double		Salary ;
	double		Commission ;
	int			Deptno ;
	std::string	Deptname ;
	struct tm	Hiredate ;

public:
	emp () {
		time_t		current ;
		time (&current) ;
		localtime_r (&current, &Hiredate) ;
	}
	int GetEmpno () const {
		return Empno ;
	}
	void SetEmpno (int _Empno) {
		Empno = _Empno ;
	}
	const std::string& GetName () const {
		return Name ;
	}
	void SetName (const std::string& _Name) {
		Name = _Name ;
	}
	const std::string& GetJob () const {
		return Job ;
	}
	void SetJob (const std::string& _Job) {
		Job = _Job ;
	}
	int GetManager () const {
		return Manager ;
	}
	void SetManager (int _Manager) {
		Manager = _Manager ;
	}
	double GetSalary () const {
		return Salary ;
	}
	void SetSalary (double _Salary) {
		Salary = _Salary ;
	}
	double GetCommission () const {
		return Commission ;
	}
	void SetCommission (double _Commission) {
		Commission = _Commission ;
	}
	int GetDeptno () const {
		return Deptno ;
	}
	void SetDeptno (int _Deptno) {
		Deptno = _Deptno ;
	}
	const std::string& GetDeptname () const {
		return Deptname ;
	}
	void SetDeptname (const std::string& _Deptname) {
		Deptname = _Deptname ;
	}
	const struct tm& GetHiredate () const {
		return Hiredate ;
	}
	void SetHiredate (const struct tm& _Hiredate) {
		Hiredate = _Hiredate ;
	}

	int Print () {
		std::cout << std::left << std::setw(7) << Empno ;
		std::cout << std::left << std::setw(12) << Name ;
		std::cout << std::left << std::setw(10) << Job ;
		std::cout << std::left << std::setw(25) << Dame::Util::Date(Hiredate).AsString() ;
		std::cout << std::left << std::setw(11) << Manager ;
		std::cout << std::left << std::setw(10) << Salary ;
		std::cout << std::left << std::setw(15) << Commission ;
		std::cout << std::left << std::setw(15) << Deptno ;
		std::cout << std::left << std::setw(14) << Deptname << std::endl ;
		return 0 ;
	}

	static int PrintDetails (emp* e) {
		e->Print () ;
		/* Return 0 ensures that the record passed is deleted and the call is made again */
		return 0 ;
	}

} ;

	} // namespace ExampleDb
} // namespace Dame

# endif
